Option Compare Binary
Option Explicit On
Option Strict On

Imports System.IO
Imports System.Text

Public Class ExtendedBinaryReader
    Inherits BinaryReader

    Public Sub New(ByVal Input As Stream)
        MyBase.New(Input)
    End Sub

    Public Sub New(ByVal Input As Stream, ByVal Encoding As Encoding)
        MyBase.New(Input, Encoding)
    End Sub

    Public Function ReadNullTerminatedString() As String
        Dim Value As New StringBuilder(20)
        Dim c As Char = Me.ReadChar()
        Do While Not c = ControlChars.NullChar
            Value.Append(c)
            c = Me.ReadChar()
        Loop
        Return Value.ToString()
    End Function

    Public Function ReadBigEndianUInt32() As UInt32
        Dim Bytes() As Byte = Me.ReadBytes(4)
        Array.Reverse(Bytes)
        Return BitConverter.ToUInt32(Bytes, 0)
    End Function

    Public Function ReadFixedLengthString(ByVal Length As Integer) As String
        Return CStr(Me.ReadChars(Length))
    End Function

    Public Sub SeekNextEvenPosition()
        If Me.BaseStream.Position Mod 2 <> 0 Then
            Me.BaseStream.Position += 1
        End If
    End Sub
End Class