Option Compare Binary
Option Explicit On
Option Strict On

Imports WinForms = System.Windows.Forms

Public Class MainForm
    Private WithEvents m_Library As LibFile

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        Me.OpenFileDialog1.Filter = "Library Files (*.lib)|*.lib|All Files (*.*)|*.*"
    End Sub

    Private Sub Library_ParseError(ByVal sender As Object, ByVal e As ParseErrorEventArgs) Handles m_Library.ParseError
        Me.ListBoxParseErrors.Items.Add(e.ToString())
    End Sub

    Private Sub ButtonOpen_Click(ByVal sender As Object, ByVal e As EventArgs) Handles ButtonOpen.Click
        If Me.OpenFileDialog1.ShowDialog() = WinForms.DialogResult.OK Then
            Me.UseWaitCursor = True
            Application.DoEvents()
            m_Library = New LibFile()
            Me.TextBoxDllFileName.Clear()
            Application.DoEvents()
            Me.ListBoxImportNames.DataSource = Nothing
            Me.ListBoxParseErrors.Items.Clear()
            Me.ListBoxSymbolDetails.Items.Clear()
            Me.TextBoxDllFileName.Text = Me.OpenFileDialog1.FileName
            Try
                m_Library.Load(Me.OpenFileDialog1.FileName)
            Catch ex As Exception
                MsgBox(ex.ToString(), MsgBoxStyle.Exclamation)
            End Try
            Me.ListBoxImportNames.DisplayMember = "Name"
            Me.ListBoxImportNames.DataSource = m_Library.ImportSymbols
            Me.UseWaitCursor = False
        End If
    End Sub

    Private Sub ListBox1_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles ListBoxImportNames.SelectedIndexChanged
        Me.ListBoxSymbolDetails.Items.Clear()
        If Me.ListBoxImportNames.SelectedItem IsNot Nothing Then
            Dim Symbol As ImportSymbol = DirectCast(Me.ListBoxImportNames.SelectedItem, ImportSymbol)
            With Me.ListBoxSymbolDetails.Items
                .Add("Decorated symbol name:  " & Symbol.Name)
                .Add("Undecorated symbol name:  " & LibFile.GetUndecoratedName(Symbol.Name))
                .Add("DLL name:  " & Symbol.DllName)
                .Add("Paramters length:  " & LibFile.GetParamsLength(Symbol.Name))
                .Add("Ordinal/Hint:  " & Symbol.OrdinalHint)
                .Add("Import name type:  " & Symbol.ImportNameType.ToString())
                .Add("Import type:  " & Symbol.ImportType.ToString())
                .Add("Machine:  " & Symbol.Machine.ToString())
            End With
        End If
    End Sub
End Class